package nc.ui.gl.newextendreportdef;

import java.awt.Font;
import java.awt.Insets;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import javax.swing.JFrame;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableColumn;
import nc.bs.logging.Log;
import nc.ui.gl.newextendreportdef.DefModel;
import nc.ui.glpub.IParent;
import nc.ui.glpub.IUiPanel;
import nc.ui.ml.NCLangRes;
import nc.ui.pub.ButtonObject;
import nc.ui.pub.ClientEnvironment;
import nc.ui.pub.ToftPanel;
import nc.ui.pub.beans.MessageDialog;
import nc.ui.pub.beans.UITablePane;
import nc.ui.pub.print.PrintDirectEntry;
import nc.vo.bd.b54.GlorgbookVO;
import nc.vo.gl.extendreport.PlanebookVO;
import nc.vo.glcom.tools.GLPubProxy;
import nc.vo.pub.lang.UFBoolean;

public class DefList extends ToftPanel implements PropertyChangeListener, IUiPanel {

   public String[] m_sColumnName = new String[]{NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000053"), NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000054"), NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000008"), NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000009"), NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000029"), NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000055"), NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000056"), NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000030")};
   protected ButtonObject m_btnNew = new ButtonObject(NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000061"), NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000061"), 2, "新增");
   protected ButtonObject m_btnMod = new ButtonObject(NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000015"), NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000015"), 2, "修改");
   protected ButtonObject m_btnBrowse = new ButtonObject(NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000062"), NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000062"), 2, "浏览");
   protected ButtonObject m_btnDel = new ButtonObject(NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000018"), NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000018"), 2, "删除");
   protected ButtonObject m_btnPrint = new ButtonObject(NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000019"), NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000019"), 2, "打印");
   protected ButtonObject m_btnRefresh = new ButtonObject(NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000013"), NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000013"), 2, "刷新");
   protected ButtonObject[] m_buttons;
   private UITablePane ivjUITablePane;
   private DefList.DefTableModel m_TableModel;
   private DefModel m_Model;
   private IParent m_parent;
   private ClientEnvironment ce;


   public DefList() {
      this.m_buttons = new ButtonObject[]{this.m_btnNew, this.m_btnMod, this.m_btnBrowse, this.m_btnDel, this.m_btnRefresh, this.m_btnPrint};
      this.ivjUITablePane = null;
      this.ce = ClientEnvironment.getInstance();
      this.initialize();
   }

   public void addListener(Object objListener, Object objUserdata) {
   }

   public ButtonObject[] getButtons() {
      return this.m_buttons;
   }

   private DefModel getModel() {
      if(this.m_Model == null) {
         this.m_Model = new DefModel();
         this.m_Model.addPropertyChangeListener(this);
      }

      return this.m_Model;
   }

   public DefList.DefTableModel getTableModel() {
      if(this.m_TableModel == null) {
         this.m_TableModel = new DefList.DefTableModel(null);
      }

      return this.m_TableModel;
   }

   public String getTitle() {
      return NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000063");
   }

   private UITablePane getUITablePane() {
      if(this.ivjUITablePane == null) {
         try {
            this.ivjUITablePane = new UITablePane();
            this.ivjUITablePane.setName("UITablePane");
            this.ivjUITablePane.getTable().setModel(this.getTableModel());
            this.initTablePane();
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjUITablePane;
   }

   private void handleException(Throwable exception) {
      exception.printStackTrace(System.out);
      this.showErrorMessage(exception.getMessage());
   }

   private void initialize() {
      try {
         this.setName("DefList");
         this.setSize(774, 419);
         this.add(this.getUITablePane(), "Center");
      } catch (Throwable var2) {
         this.handleException(var2);
      }

      this.onRefresh();
   }

   private void initTablePane() {
      this.getUITablePane().getTable().setAutoResizeMode(0);
      TableColumn aColumn = this.getUITablePane().getTable().getColumn(this.getUITablePane().getTable().getColumnName(0));
      aColumn.setPreferredWidth(150);
      aColumn = this.getUITablePane().getTable().getColumn(this.getUITablePane().getTable().getColumnName(1));
      aColumn.setPreferredWidth(200);
      aColumn = this.getUITablePane().getTable().getColumn(this.getUITablePane().getTable().getColumnName(2));
      aColumn.setPreferredWidth(150);
      aColumn = this.getUITablePane().getTable().getColumn(this.getUITablePane().getTable().getColumnName(3));
      aColumn.setPreferredWidth(150);
      aColumn = this.getUITablePane().getTable().getColumn(this.getUITablePane().getTable().getColumnName(4));
      aColumn.setPreferredWidth(200);
      aColumn = this.getUITablePane().getTable().getColumn(this.getUITablePane().getTable().getColumnName(5));
      aColumn.setPreferredWidth(150);
      aColumn = this.getUITablePane().getTable().getColumn(this.getUITablePane().getTable().getColumnName(6));
      aColumn.setPreferredWidth(80);
      aColumn = this.getUITablePane().getTable().getColumn(this.getUITablePane().getTable().getColumnName(7));
      aColumn.setPreferredWidth(80);
   }

   public Object invoke(Object objData, Object objUserData) {
      return null;
   }

   public static void main(String[] args) {
      try {
         JFrame exception = new JFrame();
         DefList aDefList = new DefList();
         exception.setContentPane(aDefList);
         exception.setSize(aDefList.getSize());
         exception.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
               System.exit(0);
            }
         });
         exception.show();
         Insets insets = exception.getInsets();
         exception.setSize(exception.getWidth() + insets.left + insets.right, exception.getHeight() + insets.top + insets.bottom);
         exception.setVisible(true);
      } catch (Throwable var4) {
         Log.getInstance(DefList.class).error(var4);
      }

   }

   public void nextClosed() {
   }

   private void onBrowse() {
      try {
         int ex = this.getUITablePane().getTable().getSelectedRow();
         if(ex > -1) {
            IUiPanel panel = (IUiPanel)this.m_parent.showNext("nc.ui.gl.newextendreportdef.DefPanel");
            panel.invoke(this.getModel().getData()[ex], "modify");
            panel.addListener(this, "browse");
         }
      } catch (Exception var3) {
         this.handleException(var3);
      }

   }

   public void onButtonClicked(ButtonObject bo) {
      if(bo.equals(this.m_btnNew)) {
         this.onNew();
      } else if(bo.equals(this.m_btnMod)) {
         this.onModify();
      } else if(bo.equals(this.m_btnBrowse)) {
         this.onBrowse();
      } else if(bo.equals(this.m_btnDel)) {
         this.onDel();
      } else if(bo.equals(this.m_btnPrint)) {
         this.onPrint();
      } else if(bo.equals(this.m_btnRefresh)) {
         this.onRefresh();
      }

   }

   private void onDel() {
      try {
         int ex = this.getUITablePane().getTable().getSelectedRow();
         if(ex > -1) {
            String definer = this.getModel().getData()[ex].getPk_operator();
            if((definer == null || !definer.equals(this.ce.getUser().getPrimaryKey())) && definer != null) {
               if(definer != null && !definer.equals(this.ce.getUser().getPrimaryKey())) {
                  MessageDialog.showHintDlg(this, NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000065"), NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000066"));
               }
            } else if(MessageDialog.showYesNoDlg(this, NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000018"), NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000064")) == 4) {
               this.getModel().delete(ex);
               this.onRefresh();
            }
         }
      } catch (Exception var3) {
         this.handleException(var3);
      }

   }

   private void onModify() {
      try {
         int ex = this.getUITablePane().getTable().getSelectedRow();
         if(ex > -1) {
            String definer = this.getModel().getData()[ex].getPk_operator();
            if((definer == null || !definer.equals(this.ce.getUser().getPrimaryKey())) && definer != null) {
               if(definer != null && !definer.equals(this.ce.getUser().getPrimaryKey())) {
                  MessageDialog.showHintDlg(this, NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000065"), NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000067"));
               }
            } else {
               IUiPanel panel = (IUiPanel)this.m_parent.showNext("nc.ui.gl.newextendreportdef.DefPanel");
               panel.invoke(this.getModel().getData()[ex], "modify");
               panel.addListener(this, "modify");
            }
         }
      } catch (Exception var4) {
         this.handleException(var4);
      }

   }

   private void onNew() {
      try {
         GLPubProxy.getRemoteExtendRpt().sysBdInfo();
         PlanebookVO ex = new PlanebookVO();
         IUiPanel panel = (IUiPanel)this.m_parent.showNext("nc.ui.gl.newextendreportdef.DefPanel");
         ex.setPk_glorgbook(this.getPk_glorgbook());
         panel.addListener(this, "new");
         panel.invoke(ex, "new");
      } catch (Exception var3) {
         this.handleException(var3);
         var3.printStackTrace();
      }

   }

   private void onPrint() {
      try {
         int[] e = new int[this.m_sColumnName.length];
         int[] alignflag = new int[this.m_sColumnName.length];

         for(int data = 0; data < this.m_sColumnName.length; ++data) {
            e[data] = 150;
            alignflag[data] = 1;
         }

         Object[][] var10 = new Object[this.getUITablePane().getTable().getRowCount()][this.m_sColumnName.length];

         for(int title = 0; title < this.getUITablePane().getTable().getRowCount(); ++title) {
            for(int font = 0; font < this.m_sColumnName.length; ++font) {
               var10[title][font] = this.getTableModel().getValueAt(title, font);
            }
         }

         String var11 = "test";
         Font var12 = new Font("dialog", 1, 20);
         Font font1 = new Font("dialog", 0, 12);
         String[][] botstr = new String[][]{{NCLangRes.getInstance().getStrByID("200213", "UPP200213-000010") + this.ce.getCorporation().getUnitname(), NCLangRes.getInstance().getStrByID("200213", "UPP200213-000042") + this.ce.getBusinessDate().toString()}, {NCLangRes.getInstance().getStrByID("200213", "UPP200213-000012") + this.ce.getUser().getUserName().toString(), NCLangRes.getInstance().getStrByID("200213", "UPP200213-000043")}};
         PrintDirectEntry print = new PrintDirectEntry();
         print.setTitle(this.getTitle());
         print.setTitleFont(var12);
         print.setContentFont(font1);
         print.setBStrColRange(new int[]{1, 3});
         print.setBottomStr(botstr);
         print.setBottomStrAlign(2);
         print.setColNames(new String[][]{this.m_sColumnName});
         print.setData(var10);
         print.setColWidth(e);
         print.setAlignFlag(alignflag);
         print.setPageNumDisp(true);
         print.setPageNumAlign(1);
         print.preview();
      } catch (Exception var9) {
         this.reportException(var9);
      }

   }

   private void onRefresh() {
      try {
         this.getModel().refresh();
      } catch (Exception var2) {
         this.handleException(var2);
      }

   }

   public void propertyChange(PropertyChangeEvent evt) {
      if(evt.getSource().equals("new")) {
         if(evt.getPropertyName().equals("success")) {
            this.onRefresh();
         }
      } else if(evt.getSource().equals("modify")) {
         if(evt.getPropertyName().equals("success")) {
            this.onRefresh();
         }
      } else if(evt.getSource() == this.getModel() && evt.getPropertyName().equals("refresh")) {
         if(evt.getNewValue() == null) {
            this.getTableModel().setData((PlanebookVO[])null);
         } else {
            this.getTableModel().setData((PlanebookVO[])((PlanebookVO[])evt.getNewValue()));
         }
      }

   }

   public void removeListener(Object objListener, Object objUserdata) {
   }

   public void showMe(IParent parent) {
      parent.getUiManager().removeAll();
      parent.getUiManager().add(this, this.getName());
      if(parent instanceof ToftPanel) {
         ToftPanel new_name = (ToftPanel)parent;
         String orgbookname = ((GlorgbookVO)ClientEnvironment.getInstance().getValue("pk_glorgbook")).getGlorgbookname();
         new_name.updateStatusBarAccountMsg(orgbookname);
      }

      this.m_parent = parent;
      this.onRefresh();
   }

   private String getPk_glorgbook() {
      return ((GlorgbookVO)ClientEnvironment.getInstance().getValue("pk_glorgbook")).getPrimaryKey();
   }

   private class DefTableModel extends AbstractTableModel {

      private PlanebookVO[] m_DefVOs;
      private int[] m_iColKeys;


      private DefTableModel() {
         this.m_DefVOs = null;
         this.m_iColKeys = new int[]{99, 9, 21, 22, 3, 10, 13, 12};
      }

      public int getColumnCount() {
         return this.m_iColKeys.length;
      }

      public int getRowCount() {
         return this.m_DefVOs == null?0:this.m_DefVOs.length;
      }

      public Object getValueAt(int param1, int param2) {
         try {
            Object ex = this.m_DefVOs[param1].getValue(this.m_iColKeys[param2]);
            switch(this.m_iColKeys[param2]) {
            case 10:
               if(ex != null && ((UFBoolean)ex).booleanValue()) {
                  return NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000057");
               }

               return NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000058");
            case 12:
               if(ex != null && ex.toString().trim().equals("P")) {
                  return NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000059");
               }

               return NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000060");
            default:
               return ex;
            }
         } catch (Exception var4) {
            return null;
         }
      }

      public String getColumnName(int column) {
         return DefList.this.m_sColumnName[column];
      }

      public void setData(PlanebookVO[] data) {
         this.m_DefVOs = data;
         this.fireTableDataChanged();
      }

      // $FF: synthetic method
      DefTableModel(Object x1) {
         this();
      }
   }
}
